{def_ttudpval.i}
{def_ttresults.i}
{def_dscontactlight.i}

DEFINE TEMP-TABLE TTParam NO-UNDO
    FIELDS cCode AS CHAR
    FIELDS cValue AS CHAR.

DEFINE TEMP-TABLE ttsearchcriteria NO-UNDO
    FIELD searchfieldName AS CHAR
    FIELD searchfieldValue AS CHAR.

DEFINE TEMP-TABLE ttinputparam NO-UNDO
    FIELD szcode AS CHAR
    FIELD szvalue AS CHAR.


  /*
  DEFINE INPUT PARAMETER dUserObj                     AS DECIMAL     NO-UNDO.
  DEFINE INPUT PARAMETER szName                       AS CHARACTER   NO-UNDO.
  DEFINE INPUT PARAMETER iActiveInactiveContacts      AS INTEGER NO-UNDO. /* 0 = both, 1 = only active contacts, 2 = only inactive contacts */  
  */

  DEFINE INPUT PARAMETER filter AS CHARACTER NO-UNDO.
  DEFINE OUTPUT PARAMETER DATASET FOR dsContactLight.

 DEFINE VARIABLE dUserObj       AS DECIMAL        NO-UNDO.
 DEFINE VARIABLE szName         AS CHARACTER      NO-UNDO.
 DEFINE VARIABLE iActiveInactiveContacts   AS INTEGER     NO-UNDO.
 DEFINE VARIABLE szlong         AS LONGCHAR   NO-UNDO.

  DEFINE VARIABLE iErrnb          AS INTEGER     NO-UNDO.
  DEFINE VARIABLE szErrParam      AS CHARACTER   NO-UNDO.

  DEFINE VARIABLE iStartPos AS INTEGER NO-UNDO.                 /* input: positie van eerste op te halen record -> tellen vanaf 1 (1-based !!!) - Indien NEGATIEF: ophalen vanaf LAATSTE record / output: nieuwe eindpositie voor volgende query */
  DEFINE VARIABLE iEndPos AS INTEGER NO-UNDO.                   /* input: max. aantal op te halen records / output : nieuwe beginpositie voor volgende query !!! */
  DEFINE VARIABLE szDirection AS CHAR NO-UNDO. 

  ASSIGN iStartPos = 1
         iEndPos = 200
         szDirection = "N".

  /* input parameters uitlezen */
  EMPTY TEMP-TABLE ttinputparam.
  szlong = filter.
  TEMP-TABLE ttinputparam:READ-JSON("LONGCHAR", szlong, "empty").

  FOR EACH ttinputparam NO-LOCK:        

      IF ttinputparam.szcode EQ "dUserObj" THEN DO:
          dUserObj = DECIMAL(szvalue).
      END.
      ELSE IF ttinputparam.szcode EQ "szName" THEN DO:
          szName = szvalue.
      END.
      ELSE IF ttinputparam.szcode EQ "iActiveInactiveContacts" THEN DO:
         iActiveInactiveContacts = INT(szvalue).
      END.
  END.                                     
 
  RUN procs/adv_qry_contacts.p(INPUT-OUTPUT iStartPos,         /* iStartPos */ 
                               INPUT-OUTPUT iEndPos,           /* iEndPos */
                               INPUT-OUTPUT szDirection,       /* szDirection */
                               INPUT "A",      /* szUDP_AndOr */
                               INPUT szName,    /* szName*/
                               INPUT 0,        /* dContactType_obj */   
                               INPUT 0,        /* dLanguageObj */ 
                               INPUT "",        /* szStreet */
                               INPUT 0,        /* dCity_obj */
                               INPUT "",        /* szCountryCode */
                               INPUT "",        /* szZipCode */
                               INPUT "",        /* szCityCallout */
                               INPUT FALSE,     /* bSearchOnZipRange */
                               INPUT "",        /* szZipFrom */
                               INPUT "",        /* szZipTo */
                               INPUT "",        /* szTel */
                               INPUT "",        /* szEmail */
                               INPUT "",        /* szUrl */
                               INPUT "",        /* szVAT */
                               INPUT 0,         /* dFunctionObj */
                               INPUT "",        /* szCategories */
                               INPUT 0,        /* dRepresentative_obj */
                               INPUT 0,        /* dDiasType_obj */
                               INPUT "",        /* szVR */
                               INPUT TRUE,     /* bVRAnd */
                               INPUT "",        /* DtMode */
                               INPUT TODAY,         /* dtfrom */
                               INPUT TODAY,         /* dttill */
                               INPUT "",        /* ftstring */
                               INPUT "Contains",        /* ftmode */
                               INPUT TRUE,     /* ftand */
                               INPUT 0,        /* Processing_obj */
                               INPUT 0,        /* ItemState_obj */
                               INPUT "LastName",        /* szSortColumn */
                               INPUT dUserObj,  /* dDiasuser_obj */
                               INPUT iActiveInactiveContacts,         /* iActiveInactiveContacts */
                               INPUT TABLE ttUDPVal,   /* ttUDPVal */ 
                               INPUT 0,        /* dList_obj */
                               INPUT FALSE,     /* lReturnCounter */
                               INPUT FALSE,     /* lSearchOnLocation */    
                               INPUT TABLE ttsearchcriteria, /* ttsearchcriteria */
                               OUTPUT TABLE ttResults,
                               OUTPUT iErrnb,
                               OUTPUT szErrParam,
                               OUTPUT TABLE TTParam
                             ).
                           
  /* 2nd call voor de details van de contacten */
  RUN procs/get_contacts_light.p (INPUT dUserObj,             /* duser_obj */ 
                                  INPUT TABLE ttResults,      /* ttResults*/     
                                  OUTPUT DATASET dsContactLight /* dsContactLight*/
                                  ).     
            
                             
                             
                             
                             
                      
